package ufz.aloe.urban.controler;

/**
 * Property values for ResmobCity are stored here.
 * Number of time steps, names and paths for initial data
 * 
 * @author nschwarz *
 */
public final class Properties {

	public static final int NUMBER_OF_TIMESTEPS = 5;
	
	// raster data
	public static final String FILE_LANDPARCELID = "data/spatially/raster/landparcelID.asc";	
	public static final String FILE_LANDPARCELDIST = "data/spatially/raster/landparcelDist.asc";	
	public static final String FILE_GREENERY = "data/spatially/raster/greenery.asc";
	
	public static final String PATH_STRUCTTYPES = "data/spatially/raster/StruType_";
	
	// point data with x y coordinates
	public static final String FILE_HOUSES_OUT = "data/spatially/point/houses_out.csv";
	public static final String FILE_SCHOOLS = "data/spatially/point/schools.csv";
	public static final String FILE_SHOPPING = "data/spatially/point/shopping.csv";
	
	
	// csv data per structure type
	public static final String FILE_STRUCTURETYPE = "data/spatially/perStructureType/structureType.csv";

	// csv data per borough
	public static final String FILE_BOROUGH = "data/spatially/perBorough/borough.csv";
	
	// csv data per land parcel
	public static final String FILE_LANDPARCEL_INPUT = "data/spatially/perLandParcel/landParcel.csv";
	

	// csv data per household type
	public static final String FILE_HOUSEHOLDTYPE = "data/residential/perHouseholdType/householdType.csv";
	public static final String FILE_ATTRACT_POPDENS = "data/residential/perHouseholdType/attractivenessPopDens.csv";
	public static final String FILE_ATTRACT_STRUCTTYPE = "data/residential/perHouseholdType/attractivenessStructureType.csv";
	public static final String FILE_ATTRACT_INFRASTRUCTURE = "data/residential/perHouseholdType/attractivenessInfrastructure.csv";
	public static final String FILE_ATTRACT_GREENERY = "data/residential/perHouseholdType/attractivenessGreenery.csv";
	public static final String FILE_HOUSEHOLDTYPE_CONSTRAINTS = "data/residential/perHouseholdType/householdTypeConstraints.csv";
	public static final String FILE_WEIGHTS_PARAMETERS = "data/residential/perHouseholdType/weightsOfParameters.csv";
	public static final String FILE_BUDGET = "data/residential/perHouseholdType/budget.csv";
	
	// csv data per cohort
	public static final String FILE_COHORTS = "data/residential/perCohort/cohorts.csv";
	public static final String FILE_MOVEIN = "data/residential/perCohort/move_in.csv";
	
	// csv: distance for searching
	public static final String FILE_MAX_PROPERTYDISTANCE = "data/residential/maximumPropertyDistances.csv";

}
