package ufz.aloe.urban.model;

public class Flat implements Comparable{
	
	private static int sortField; 
	private float []attractiveness; // attractiveness is a vector of household type
	private LandParcel landParcel;
	private StructureType structureType;
	private Building building;

	public Flat( LandParcel landParcel, StructureType structureType) {
		this.landParcel=landParcel;
		this.structureType=structureType;
		
	}
	public void setBuilding(Building b) {
		building=b;
	}	

		/**
	 * @return Returns the attractiveness.
	 */
	 
	public void setAttractiveness(float[] a) {
		attractiveness=a;
	}
	public float[] getAttractiveness() {
		return attractiveness;
	}
	public int compareTo( Object other ){ 
		    /* hier werden jetzt zwei Objekte miteinander verglichen 
		       einmal this und other. die methode wird automatisch 
		       von Arrays aufgerufen ... 
		    */ 
		    
		    int i=9;
			if (this.attractiveness[sortField]<((Flat)other).attractiveness[sortField])
				i=-1;
			 /* gendert: 
		     *	< => ==
		     */
		    if (this.attractiveness[sortField]==((Flat)other).attractiveness[sortField])
		    	i= 0;
			 /* gendert: 
		     *	< => >
		     */
		    if (this.attractiveness[sortField]>((Flat)other).attractiveness[sortField])
		    	i=1;
		    return i;
	 } 
	public static void setSortField(int i){ 
	   sortField = i; 
	}
	public Building getBuilding() {
		return building;
	} 
	public StructureType getStructureType() {
		return structureType;
	}
	public LandParcel getLandParcel() {
		return landParcel;
	}
	public boolean addHousehold(Household h) {
		return building.addHousehold(h);
	}
	public void removeHousehold(Household h) {
		building.removeHousehold(h);
	}
	public int getCost() {
		return building.getCost();
	}
}
