package ufz.aloe.urban.model;

public class HouseholdType {
	private int ID;
	private String householdTypes; //the household types that are available 
	private int numPersons; //the number of persons that belong to a household is a vector of
	
	private float []attractivenessWeightsPopDens; /* vector of householdTypes, inner vectors contain
	the weights the household type gives to population density of the different household types  */
	private float []attractivenessStructureTypeArray;
	private float []attractivenessInfrastructure;
	private float []attractivenessGreenery;
	private int minYearMove;
	private static float[][] householdTypeConstraints;
	private static int[] personPerHousehold;
	private static int[] maxPersonPerHousehold;
	
	public HouseholdType(
						String householdTypes, 
						int ID,
						int numPersons ,
						float []attractivenessWeightsPopDens,
						float []attractivenessStructureTypeArray,
						float []attractivenessInfrastructure,
						float []attractivenessGreenery,
						int minYearMove){
		this.ID=ID;
		this.householdTypes = householdTypes;
		this.numPersons = numPersons;
		this.attractivenessWeightsPopDens =attractivenessWeightsPopDens ;
		this.attractivenessStructureTypeArray = attractivenessStructureTypeArray;
		this.attractivenessInfrastructure = attractivenessInfrastructure;
		this.attractivenessGreenery = attractivenessGreenery;
		this.minYearMove=minYearMove;

	}
	public static void init(float[][] householdTypeConst, int[] persPerHousehold, int[] maxPersPerHousehold) {
		householdTypeConstraints=householdTypeConst;
		personPerHousehold=persPerHousehold;
		maxPersonPerHousehold=maxPersPerHousehold;
	}
	/**
	 * @return Returns the attractivenessWeightsPopDens.
	 */
	public float[] getAttractivenessWeightsPopDens() {
		return attractivenessWeightsPopDens;
	}
	public float[] getAttractivenessStructureType() {
		return attractivenessStructureTypeArray;
	}
	public float[] getAttractivenessInfrastructure() {
		return attractivenessInfrastructure;
	}
	public float[] getAttractivenessGreenery() {
		return attractivenessGreenery;
	}
	/**
	 * @return Returns the householdTypes.
	 */
	public String getHouseholdTypes() {
		return householdTypes;
	}
	/**
	 * @return Returns the personsPerHousehold.
	 */
	public int getNumPersons() {
		return numPersons;
	}
	public int getMinYearMove() {
		return minYearMove;
	}
	public int getID() {
		return ID;
	}
	public static float[][] getHouseholdTypeConstraints() {
		return householdTypeConstraints;
	}
	public static int[] getPersonPerHousehold() {
		return personPerHousehold;
	}
	public static int[] getMaxPersonPerHousehold() {
		return maxPersonPerHousehold;
	}

}
