package ufz.aloe.urban.model;

import java.lang.Math;

public class Inhabitant {
	
	private int cohort;
	private int ageInCohort;
	private static int cohortLength;
	private static float[] survival;
	private static float[] birthRate;
	
	
	public static void init(float[] surv, float[] birth, int cohortL){
		survival=surv;
		birthRate=birth;
		cohortLength=cohortL;
	}
	public Inhabitant(int cohort, int ageInCohort) {
		this.cohort=cohort;
		this.ageInCohort=ageInCohort;
	}
	/**
	 * @return number of children, if -1 this died
	 *
	 */
	public int mature() {
		ageInCohort++;
		if(ageInCohort >= cohortLength) {
			if(cohort < survival.length-1) cohort++;
			ageInCohort=0;
		}
		if(Math.random() > survival[cohort]) return -1;
		if(Math.random() < birthRate[cohort]) return 1;
		return 0;
	}
	public int getCohort() {
		return cohort;
	}
	public int getAge() {
		return cohort*cohortLength + ageInCohort;
	}
	public Inhabitant copy() {
		return new Inhabitant(cohort, ageInCohort);
	}
}
