package ufz.aloe.urban.postprocessing;

import java.io.File;
import sa.gui.FileChooser;

public class ExtractFromResults {
	
	public static final int ID=1;
	public static final int FIELD=2;
	
	protected static MetaData[] data;
	protected static String[] colNames;
	protected static String[] fileNames;

	public static void main(String[] args) {
		parameterInput();
	}
	
	
	public static void parameterInput() throws IncorrectInputException{
		FileChooser fc=new FileChooser(true);
		File[] f = fc.files(fc.TABLE, fc.OPEN,"select results");
		
		if(f!=null && f.length>0) {
			data=new MetaData[f.length] ;
			for(int i=0;i<f.length;i++) {
				data[i]=new TableReader(",", true).readFile(f[i]);
			}
			int ncol=data[0].getColumnCount();
			colNames=new String[ncol];
			fileNames=new String[f.length];
			for(int i=0;i<f.length;i++) {
				fileNames[i]=f[i].getName();
			}
			for(int i=0;i<ncol;i++) {
				String name=data[0].getColumnName(i);
				for(int j=0;j<f.length;j++) {
					if(!data[j].getColumnName(i).equals(name)) 
						throw new IncorrectInputException("unequal column names!");
				}
				colNames[i]=name;
			}
			for(int i=0;i<colNames.length;i++) {
				System.out.print(colNames[i]+",  ");
			}
			System.out.println();
			
			new ExtractFromResultsFrame(data[0], data.length);
			
			
			
		}
   		
	}
	
	public static void extract(int type, int idField, int extract) {
		Object[] columnNames=new Object[0];
		Object[][] d=new Object[0][0];
		if(type==ID) {
			columnNames = new Object[data[0].getColumnCount()+1];
			columnNames[0]="file";
			d = new Object[data.length][data[0].getColumnCount()+1];
			for(int c=1;c<columnNames.length;c++) {
				columnNames[c]=data[0].getColumnName(c-1);
				for(int r=0;r<d.length;r++) {
					d[r][0] = fileNames[r];
					d[r][c] = data[r].getValueAt(extract, c-1);
				}
			}
		}
		
		
		if(type==FIELD) {
			columnNames = new Object[data.length+1];
			d = new Object[data[0].getRowCount()][data.length+1];
			columnNames[0]=data[0].getColumnName(idField);
			for(int c=1;c<columnNames.length;c++) {
				columnNames[c]=fileNames[c-1];
				for(int r=0;r<d.length && r<data[c-1].getRowCount();r++) {
					d[r][0] = data[0].getValueAt(r, idField);
					d[r][c] = data[c-1].getValueAt(r, extract);
				}
			}
		}
		
		
		MetaData result=new MetaData(d, columnNames);
		
		FileChooser fc=new FileChooser(false);
		File f = fc.file(fc.TABLE, fc.SAVE,"select file");
		
		new TableReader(",", true).writeFile(result, f);
		
		
	}
		
}
