package ufz.aloe.urban.postprocessing;


import java.util.StringTokenizer;

public abstract class StringHandler {
	
	public final static int TYPE_1 = 0; // ();
	public final static int TYPE_2 = 1; // [];
	public final static int TYPE_3 = 2; // {};
	
	public static String[] splitString(String text, String del) {
		
		String[] ret;
		StringTokenizer tokenizer = new StringTokenizer( text, del );
		ret = new String[tokenizer.countTokens()];
    
		for ( int i = 0; tokenizer.hasMoreTokens(); ++i ) {
  			ret[i] = tokenizer.nextToken();
		}

		return ret;
	}
	public static String[] splitLines(String text) {
		
		String[] ret;
		StringTokenizer tokenizer = new StringTokenizer( text, "\n" );
		ret = new String[tokenizer.countTokens()];
    
		for ( int i = 0; tokenizer.hasMoreTokens(); ++i ) {
  			ret[i] = tokenizer.nextToken();
		}

		return ret;
	}
	public static String mergeStringsLine(String[] s) {
		String str = "";
		for(int i = 0; i < s.length; i++) {
			str = str + s[i] + "\n";
			
		}
		return str;
	}
	public static String mergeStringsSpace(String[] s) {
		String str = "";
		for(int i = 0; i < s.length; i++) {
			str = str + s[i] + " ";
			
		}
		return str;
	}
	public static String replace( String s, String search, String replace ){
	    int start = 0, pos = 0;
	    StringBuffer result = new StringBuffer( s.length() );
	    while ( (pos = s.indexOf(search, start)) >= 0 )
	    {
	      result.append( s.substring(start, pos) );
	      result.append( replace );
	      start = pos + search.length();
	    }
	    result.append( s.substring(start) );
	    
	    return result.toString();
  	}
  	public static String[] addString(String[] arr, String s) {
		//System.out.println(s);
		String[] a;
		if(arr.length == 0) a = new String[1];
		else a = new String[arr.length+1];
		for(int i = 0; i < a.length-1; i++) {
			a[i] = arr[i];
		}
		a[a.length-1] = ""+s;
		arr = a;
		return arr;
}
	
	public static String extractBrackets(String s, int type, String[] replace, String[] with) {
		String ret = new String();
		char b1='(', b2=')'; 
		boolean done = false;
		boolean inBracket = false;
		if(type==TYPE_1) {b1='(';b2=')';} 
		else if(type==TYPE_2) {b1='[';b2=']';} 
			else if(type==TYPE_3) {b1='{';b2='}';}
		int c = 0;
		int start=0;
		int end=-1;
		while(!done) {
			if(!inBracket){
				if(s.charAt(c) == b1) {
					inBracket = true;
					start = c;
					ret=ret.concat(s.substring(end+1, c));
				} else if(c==s.length()-1) {
						ret=ret.concat(s.substring(end+1, c+1));
					}
			} else {
				if(s.charAt(c) == b2) {
					inBracket = false;
					end = c;
					String repl = s.substring(start+1, c);
					
					boolean found = false;
					for(int i = 0; i < replace.length && i < with.length && !found; i++) {
						if(repl.equals(replace[i])) {
							
							found = true;
							ret=ret.concat(with[i]);
						}
					}
				}
			}
			c++;
			if(c==s.length()) done = true;
		}
		return ret;
		
		
	}
	public static String[] getRasters(String s, int type, String[] replace, String[] with) {
		String[] ret = new String[0];
		char b1='(', b2=')'; 
		boolean done = false;
		boolean inBracket = false;
		if(type==TYPE_1) {b1='(';b2=')';} 
		else if(type==TYPE_2) {b1='[';b2=']';} 
			else if(type==TYPE_3) {b1='{';b2='}';}
		int c = 0;
		int start=0;
		int end=-1;
		while(!done) {
			if(!inBracket){
				if(s.charAt(c) == b1) {
					inBracket = true;
					start = c;
					//ret=ret.concat(s.substring(end+1, c));
				}
			} else {
				if(s.charAt(c) == b2) {
					inBracket = false;
					end = c;
					String repl = s.substring(start+1, c);
					
					boolean found = false;
					for(int i = 0; i < replace.length && i < with.length && !found; i++) {
						if(repl.equals(replace[i])) {
							
							found = true;
							ret=addString(ret, repl);
						}
					}
				}
			}
			c++;
			if(c==s.length()) done = true;
		}
		return ret;
		
		
	}
	public static double getDouble(String s) throws NumberFormatException {
		return Double.valueOf( s ).doubleValue();
	}
	public static int getInt(String s) throws NumberFormatException  {
		return Integer.valueOf(s).intValue();
	}
	
}
