package ufz.aloe.urban.postprocessing;

import java.util.*;
import java.io.*;
import java.util.StringTokenizer;
import ufz.aloe.urban.postprocessing.StringHandler;


public class TableReader extends StringHandler {
	
	protected String delimiter;
	protected boolean namesFromFirstRow;
	
	public TableReader(String delim, boolean namesFromFirstRow) {
		delimiter=delim;
		this. namesFromFirstRow= namesFromFirstRow;
	}	
	public MetaData readFile (String f) {
		return readFile (new File(f));
	}
	public MetaData readFile (File f) {
		String[] s = new String[0];
		String[][] data;
    	MetaData ret;
    	int nrow, ncol;
   	 	try
    	{
    	  Reader fr = new FileReader( f );
    	  LineNumberReader fn = new LineNumberReader( fr );
		  String line; 
	      while ( (line = fn.readLine()) != null ) {
	      	s = addString(s, line);
   	      }
   		   fn.close();
   		}
   		catch ( IOException e ) {
    	  System.out.println( "Fehler beim Lesen der Datei" );
    	}
    	int line = 0;
    	StringTokenizer cntr = new StringTokenizer( s[0], delimiter);
    	data=new String[s.length][cntr.countTokens()];
    	nrow=s.length;
    	ncol=cntr.countTokens();
    	for(int i = 0; i < s.length; i++) {
    		boolean l = false;
    		int word = 0;
    		
  			StringTokenizer st = new StringTokenizer( s[i], delimiter);
  			String w[] = new String[st.countTokens()];
  			for ( int j = 0; st.hasMoreTokens(); j++ ) {
    			w[j] = st.nextToken();	
    			if(!l){ line++; l = true;}
    			word++;
    			data[line-1][word-1] = w[j];
 			}
   		}
   		if(namesFromFirstRow) {
   			Vector names = new Vector();
   			for(int i = 0; i < ncol; i++) {
   				names.add(data[0][i]);
   			}
   			ret=new MetaData(names, nrow-1);
   			for(int i = 0; i < ncol; i++) {
   				for(int j = 1; j < nrow; j++) {
   					ret.setValueAt( data[j][i], j-1, i);
   				}
   			}
   		}
   		else {
   			ret=new MetaData( nrow, ncol);
   			for(int i = 0; i < ncol; i++) {
   				for(int j = 0; j < nrow; j++) {
   					ret.setValueAt( data[j][i], j, i);
   				}
   			}
   		}
   		return ret;
   	}
   	
   	public void writeFile(MetaData md, File file) {
		StringWriter buffer = new StringWriter();
		PrintWriter out = new PrintWriter( buffer );
		
		String s = "";
		if(namesFromFirstRow) {
			String str = "";
			for(int j = 0; j < md.getColumnCount(); j++) {
				str=str.concat(""+md.getColumnName(j));
				if(j!=md.getColumnCount()-1) str=str.concat(delimiter);
				//System.out.println(r.get(i, j));
			}
			out.println(str);
		}
		for(int i = 0; i < md.getRowCount(); i++) {	
			String str = "";
			for(int j = 0; j < md.getColumnCount(); j++) {
				str=str.concat(""+md.getValueAt(i,j));
				if(j!=md.getColumnCount()-1) str=str.concat(delimiter);
				//System.out.println(r.get(i, j));
			}
			out.println(str);
			//System.out.println(i);
		}
		//System.out.println(str);
		
		
		
		String toWrite = buffer.toString();

    	
    	try {
    		FileWriter fw = new FileWriter( file );
    		fw.write( toWrite );
    		fw.close();
    	} catch ( IOException e ) {
      		System.out.println( "Konnte Datei nicht erstellen" );
    	}
	}
   	
   	
}
